package fr.irisa.cairn.jnimap.generator.c;

import fr.irisa.cairn.jniMap.CMethod;
import fr.irisa.cairn.jniMap.ClassMapping;
import fr.irisa.cairn.jniMap.Mapping;
import fr.irisa.cairn.jniMap.ParamDef;
import fr.irisa.cairn.jniMap.UserModule;
import fr.irisa.cairn.jnimap.generator.CommonExtensions;
import fr.irisa.cairn.jnimap.generator.TypeExtensions;
import fr.irisa.cairn.jnimap.generator.c.JNICUtilities;
import fr.irisa.cairn.jnimap.generator.c.JNIClassMappingTemplate;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;

/**
 * Mostly for UserModule related generation
 */
@SuppressWarnings("all")
public class JNICTemplate {
  @Extension
  private CommonExtensions _commonExtensions = new CommonExtensions();
  
  @Extension
  private TypeExtensions _typeExtensions = new TypeExtensions();
  
  @Extension
  private JNICUtilities _jNICUtilities = new JNICUtilities();
  
  @Extension
  private JNIClassMappingTemplate _jNIClassMappingTemplate = new JNIClassMappingTemplate();
  
  public void compile(final Mapping m, final IFileSystemAccess fsa) {
    fsa.generateFile(this.commonFileFilepath(m), this.commonFileContent(m));
    fsa.generateFile(this.userModulesInterfaceFilepath(m), this.userModulesInterfaceContent(m));
    EList<ClassMapping> _classMapping = m.getClassMapping();
    for (final ClassMapping cm : _classMapping) {
      this._jNIClassMappingTemplate.compile(cm, m, fsa);
    }
    EList<UserModule> _userModules = m.getUserModules();
    for (final UserModule module : _userModules) {
      {
        fsa.generateFile(this.CModuleHeaderFilepath(module), this.CModuleHeaderContent(module));
        fsa.generateFile(this.CModuleFilepath(module), this.CModuleContent(module, m));
      }
    }
  }
  
  public CharSequence prefix(final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    String _replaceAll = this._commonExtensions.packageName(m).replaceAll("\\.", "_");
    _builder.append(_replaceAll);
    _builder.append("_");
    String _ID = this._commonExtensions.ID(m);
    _builder.append(_ID);
    _builder.append("Native");
    return _builder;
  }
  
  public String commonFileFilepath(final Mapping m) {
    CharSequence _cRootPath = this._commonExtensions.cRootPath();
    String _name = m.getName();
    String _plus = (_cRootPath + _name);
    return (_plus + "_common_native.c");
  }
  
  public String CModuleFilepath(final UserModule um) {
    CharSequence _cRootPath = this._commonExtensions.cRootPath();
    String _identifier = this._commonExtensions.identifier(um);
    String _plus = (_cRootPath + _identifier);
    return (_plus + ".c");
  }
  
  public String CModuleHeaderFilepath(final UserModule um) {
    CharSequence _cRootPath = this._commonExtensions.cRootPath();
    String _identifier = this._commonExtensions.identifier(um);
    String _plus = (_cRootPath + _identifier);
    return (_plus + ".h");
  }
  
  public String userModulesInterfaceFilepath(final Mapping m) {
    CharSequence _cRootPath = this._commonExtensions.cRootPath();
    String _ID = this._commonExtensions.ID(m);
    String _plus = (_cRootPath + _ID);
    return (_plus + "_UserModules.c");
  }
  
  public CharSequence commonFileContent(final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _commonIncludes = this._jNICUtilities.commonIncludes(m);
    _builder.append(_commonIncludes);
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("#include \"");
    String _nativeInterfaceHeader = this._commonExtensions.nativeInterfaceHeader(m);
    _builder.append(_nativeInterfaceHeader);
    _builder.append("\"");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("/**");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*  Automatically generated by jnimap ");
    _builder.newLine();
    _builder.append(" ");
    _builder.append("*/");
    _builder.newLine();
    _builder.newLine();
    _builder.append("void throwException(JNIEnv * env, char* msg) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("jclass newExcCls;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("(*env)->ExceptionDescribe(env);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("(*env)->ExceptionClear(env);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("newExcCls = (*env)->FindClass(env,\"");
    String _packagePath = this._commonExtensions.packagePath(m);
    _builder.append(_packagePath, "\t");
    _builder.append("/");
    String _ID = this._commonExtensions.ID(m);
    _builder.append(_ID, "\t");
    _builder.append("Exception\");");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("if (newExcCls == NULL) {");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("/* Unable to find the exception class, give up. */");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("(*env)->ThrowNew(env, newExcCls, msg);");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("jobject createInteger(JNIEnv * env, int value) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("// Create a object of type Integer");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("jclass cls = (*env)->FindClass(env, \"java/lang/Integer\");");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("jmethodID constructorId = (*env)->GetMethodID(env, cls, \"<init>\", \"(I)V\");");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("jobject o = (*env)->NewObject(env, cls, constructorId, value);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return o;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("jint getIntegerValue(JNIEnv * env, jobject obj) {");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("jclass cls = (*env)->FindClass(env, \"java/lang/Integer\");");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("jmethodID intValueMethodId = (*env)->GetMethodID(env, cls, \"intValue\", \"()I\");");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("long val = (*env)->CallIntMethod(env, obj, intValueMethodId);");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("return (jint) val;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("JNIEXPORT jboolean JNICALL Java_");
    CharSequence _prefix = this.prefix(m);
    _builder.append(_prefix);
    _builder.append("_is_1null(JNIEnv * env, jlong ptr) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("if(ptr==(GECOS_PTRSIZE NULL))");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return JNI_TRUE ;");
    _builder.newLine();
    _builder.append("\t");
    _builder.append("else");
    _builder.newLine();
    _builder.append("    \t");
    _builder.append("return JNI_FALSE;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    _builder.append("JNIEXPORT jlong JNICALL");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("Java_");
    CharSequence _prefix_1 = this.prefix(m);
    _builder.append(_prefix_1, "\t\t");
    _builder.append("_derefPointer(JNIEnv * env, jclass class, jlong ptr) {");
    _builder.newLineIfNotEmpty();
    _builder.append("\t\t");
    _builder.append("jlong* jniptr= (jlong*) GECOS_PTRSIZE ptr;");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("if(jniptr==NULL) throwException(env, \"NPE  in pointerDeref\");");
    _builder.newLine();
    _builder.append("\t\t");
    _builder.append("return *jniptr;");
    _builder.newLine();
    _builder.append("}");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence CModuleContent(final UserModule um, final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("#include \"");
    String _identifier = this._commonExtensions.identifier(um);
    String _plus = (_identifier + ".h");
    _builder.append(_plus);
    _builder.append("\"");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("/* PROTECTED REGION ID(");
    String _name = m.getName();
    _builder.append(_name);
    _builder.append("User_");
    String _name_1 = um.getName();
    _builder.append(_name_1);
    _builder.append("_local) ENABLED START */");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    _builder.append("/* Protected region for methods used locally in this file */");
    _builder.newLine();
    _builder.append("/* PROTECTED REGION END */");
    _builder.newLine();
    _builder.newLine();
    {
      EList<CMethod> _methods = um.getMethods();
      for(final CMethod method : _methods) {
        CharSequence _prototype = this.prototype(method);
        _builder.append(_prototype);
        _builder.append(" {");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("/* PROTECTED REGION ID(");
        String _name_2 = m.getName();
        String _plus_1 = (_name_2 + "User_");
        String _name_3 = um.getName();
        String _plus_2 = (_plus_1 + _name_3);
        String _plus_3 = (_plus_2 + "_");
        String _name_4 = method.getName();
        String _plus_4 = (_plus_3 + _name_4);
        _builder.append(_plus_4, "\t");
        _builder.append(") ENABLED START */");
        _builder.newLineIfNotEmpty();
        _builder.append("\t");
        _builder.append("/* PROTECTED REGION END */");
        _builder.newLine();
        _builder.append("}");
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  public CharSequence CModuleHeaderContent(final UserModule um) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _commonIncludes = this._jNICUtilities.commonIncludes(this._commonExtensions.getRoot(um));
    _builder.append(_commonIncludes);
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("/* PROTECTED REGION ID(");
    String _identifier = this._commonExtensions.identifier(um);
    _builder.append(_identifier);
    _builder.append("_header) ENABLED START */");
    _builder.newLineIfNotEmpty();
    _builder.append("\t ");
    _builder.append("/* Custom includes for this module */");
    _builder.newLine();
    _builder.append("/* PROTECTED REGION END */");
    _builder.newLine();
    _builder.newLine();
    {
      EList<CMethod> _methods = um.getMethods();
      for(final CMethod method : _methods) {
        CharSequence _prototype = this.prototype(method);
        _builder.append(_prototype);
        _builder.append(";");
        _builder.newLineIfNotEmpty();
      }
    }
    return _builder;
  }
  
  public CharSequence prototype(final CMethod cm) {
    StringConcatenation _builder = new StringConcatenation();
    String _standardCName = this._typeExtensions.getStandardCName(cm.getRes());
    _builder.append(_standardCName);
    _builder.append(" ");
    String _name = cm.getName();
    _builder.append(_name);
    _builder.append("(");
    final Function1<ParamDef, CharSequence> _function = (ParamDef p) -> {
      return this.parameter(p);
    };
    String _join = IterableExtensions.<ParamDef>join(cm.getParams(), ", ", _function);
    _builder.append(_join);
    _builder.append(")");
    return _builder;
  }
  
  public CharSequence parameter(final ParamDef pd) {
    StringConcatenation _builder = new StringConcatenation();
    String _standardCName = this._typeExtensions.getStandardCName(pd.getType());
    _builder.append(_standardCName);
    _builder.append(" ");
    String _name = pd.getName();
    _builder.append(_name);
    return _builder;
  }
  
  public CharSequence userModulesInterfaceContent(final Mapping m) {
    StringConcatenation _builder = new StringConcatenation();
    CharSequence _commonIncludes = this._jNICUtilities.commonIncludes(m);
    _builder.append(_commonIncludes);
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("#include \"");
    String _nativeInterfaceHeader = this._commonExtensions.nativeInterfaceHeader(m);
    _builder.append(_nativeInterfaceHeader);
    _builder.append("\"");
    _builder.newLineIfNotEmpty();
    _builder.append("#include \"");
    String _nativeInterfaceHeaderForUserModule = this._commonExtensions.nativeInterfaceHeaderForUserModule(m);
    _builder.append(_nativeInterfaceHeaderForUserModule);
    _builder.append("\"");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.newLine();
    {
      EList<UserModule> _userModules = m.getUserModules();
      for(final UserModule module : _userModules) {
      }
    }
    _builder.newLine();
    {
      EList<UserModule> _userModules_1 = m.getUserModules();
      for(final UserModule module_1 : _userModules_1) {
        _builder.append("/**********************************");
        _builder.newLine();
        _builder.append(" ");
        _builder.append("** ");
        String _name = module_1.getName();
        _builder.append(_name, " ");
        _builder.newLineIfNotEmpty();
        _builder.append(" ");
        _builder.append("**********************************/");
        _builder.newLine();
        _builder.append("#include \"");
        String _identifier = this._commonExtensions.identifier(module_1);
        _builder.append(_identifier);
        _builder.append(".h\"");
        _builder.newLineIfNotEmpty();
        _builder.newLine();
        {
          EList<CMethod> _methods = module_1.getMethods();
          for(final CMethod method : _methods) {
            _builder.append("//");
            String _name_1 = module_1.getName();
            _builder.append(_name_1);
            _builder.append(" . ");
            String _name_2 = method.getName();
            _builder.append(_name_2);
            _builder.newLineIfNotEmpty();
            CharSequence _JNIFunctionHeader = this._jNICUtilities.JNIFunctionHeader(method);
            _builder.append(_JNIFunctionHeader);
            _builder.append(" {");
            _builder.newLineIfNotEmpty();
            {
              EList<ParamDef> _params = method.getParams();
              for(final ParamDef param : _params) {
                _builder.append("\t");
                String _castParam = this._jNICUtilities.castParam(param);
                _builder.append(_castParam, "\t");
                _builder.newLineIfNotEmpty();
              }
            }
            _builder.append("\t");
            _builder.newLine();
            _builder.append("\t");
            CharSequence _resultInstance = this._jNICUtilities.resultInstance(method.getRes());
            _builder.append(_resultInstance, "\t");
            _builder.append(" ");
            String _name_3 = method.getName();
            _builder.append(_name_3, "\t");
            _builder.append("(");
            final Function1<ParamDef, CharSequence> _function = (ParamDef p) -> {
              return this._jNICUtilities.paramInstance(p);
            };
            String _join = IterableExtensions.<ParamDef>join(method.getParams(), ", ", _function);
            _builder.append(_join, "\t");
            _builder.append(");");
            _builder.newLineIfNotEmpty();
            CharSequence _returnStatement = this._jNICUtilities.returnStatement(method.getRes());
            _builder.append(_returnStatement);
            _builder.newLineIfNotEmpty();
            _builder.append("}");
            _builder.newLine();
          }
        }
      }
    }
    return _builder;
  }
}
